{
  "model": {
    "type": "select",
    "property": "minecraft:charge_type",
    "cases": [
      {
        "when": "arrow",
        "model": {
          "type": "condition",
          "property": "minecraft:component",
          "component": "minecraft:enchantments",
          "predicate": "minecraft:enchantments",
          "value": [{"enchantments": "minecraft:piercing", "levels": 4}, {"enchantments": "minecraft:quick_charge", "levels": 3}],
          "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_piercing_arrow" },
          "on_false": {
            "type": "condition",
            "property": "minecraft:component",
            "component": "minecraft:enchantments",
            "predicate": "minecraft:enchantments",
            "value": [{"enchantments": "minecraft:piercing", "levels": 4}],
            "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/piercing_arrow" },
            "on_false": {
              "type": "condition",
              "property": "minecraft:component",
              "component": "minecraft:enchantments",
              "predicate": "minecraft:enchantments",
              "value": [{"enchantments": "minecraft:quick_charge", "levels": 3}],
              "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_charge_arrow" },
              "on_false": { "type": "model", "model": "minecraft:item/crossbow_arrow" }
            }
          }
        }
      },
      {
        "when": "rocket",
        "model": {
          "type": "condition",
          "property": "minecraft:component",
          "component": "minecraft:enchantments",
          "predicate": "minecraft:enchantments",
          "value": [{"enchantments": "minecraft:piercing", "levels": 4}, {"enchantments": "minecraft:quick_charge", "levels": 3}],
          "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_piercing_firework" },
          "on_false": {
            "type": "condition",
            "property": "minecraft:component",
            "component": "minecraft:enchantments",
            "predicate": "minecraft:enchantments",
            "value": [{"enchantments": "minecraft:piercing", "levels": 4}],
            "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/piercing_firework" },
            "on_false": {
              "type": "condition",
              "property": "minecraft:component",
              "component": "minecraft:enchantments",
              "predicate": "minecraft:enchantments",
              "value": [{"enchantments": "minecraft:quick_charge", "levels": 3}],
              "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_charge_firework" },
              "on_false": { "type": "model", "model": "minecraft:item/crossbow_firework" }
            }
          }
        }
      }
    ],
    "fallback": {
      "type": "condition",
      "property": "minecraft:using_item",
      "on_true": {
        "type": "range_dispatch",
        "property": "minecraft:crossbow/pull",
        "entries": [
          {
            "threshold": 0.58,
            "model": {
              "type": "condition",
              "property": "minecraft:component",
              "component": "minecraft:enchantments",
              "predicate": "minecraft:enchantments",
              "value": [{"enchantments": "minecraft:piercing", "levels": 4}, {"enchantments": "minecraft:quick_charge", "levels": 3}],
              "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_piercing_1" },
              "on_false": {
                "type": "condition",
                "property": "minecraft:component",
                "component": "minecraft:enchantments",
                "predicate": "minecraft:enchantments",
                "value": [{"enchantments": "minecraft:piercing", "levels": 4}],
                "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/piercing_1" },
                "on_false": {
                  "type": "condition",
                  "property": "minecraft:component",
                  "component": "minecraft:enchantments",
                  "predicate": "minecraft:enchantments",
                  "value": [{"enchantments": "minecraft:quick_charge", "levels": 3}],
                  "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_charge_1" },
                  "on_false": { "type": "model", "model": "minecraft:item/crossbow_pulling_1" }
                }
              }
            }
          },
          {
            "threshold": 1.0,
            "model": {
              "type": "condition",
              "property": "minecraft:component",
              "component": "minecraft:enchantments",
              "predicate": "minecraft:enchantments",
              "value": [{"enchantments": "minecraft:piercing", "levels": 4}, {"enchantments": "minecraft:quick_charge", "levels": 3}],
              "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_piercing_2" },
              "on_false": {
                "type": "condition",
                "property": "minecraft:component",
                "component": "minecraft:enchantments",
                "predicate": "minecraft:enchantments",
                "value": [{"enchantments": "minecraft:piercing", "levels": 4}],
                "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/piercing_2" },
                "on_false": {
                  "type": "condition",
                  "property": "minecraft:component",
                  "component": "minecraft:enchantments",
                  "predicate": "minecraft:enchantments",
                  "value": [{"enchantments": "minecraft:quick_charge", "levels": 3}],
                  "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_charge_2" },
                  "on_false": { "type": "model", "model": "minecraft:item/crossbow_pulling_2" }
                }
              }
            }
          }
        ],
        "fallback": {
          "type": "condition",
          "property": "minecraft:component",
          "component": "minecraft:enchantments",
          "predicate": "minecraft:enchantments",
          "value": [{"enchantments": "minecraft:piercing", "levels": 4}, {"enchantments": "minecraft:quick_charge", "levels": 3}],
          "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_piercing_0" },
          "on_false": {
            "type": "condition",
            "property": "minecraft:component",
            "component": "minecraft:enchantments",
            "predicate": "minecraft:enchantments",
            "value": [{"enchantments": "minecraft:piercing", "levels": 4}],
            "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/piercing_0" },
            "on_false": {
              "type": "condition",
              "property": "minecraft:component",
              "component": "minecraft:enchantments",
              "predicate": "minecraft:enchantments",
              "value": [{"enchantments": "minecraft:quick_charge", "levels": 3}],
              "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_charge_0" },
              "on_false": { "type": "model", "model": "minecraft:item/crossbow_pulling_0" }
            }
          }
        }
      },
      "on_false": {
        "type": "condition",
        "property": "minecraft:component",
        "component": "minecraft:enchantments",
        "predicate": "minecraft:enchantments",
        "value": [{"enchantments": "minecraft:piercing", "levels": 4}, {"enchantments": "minecraft:quick_charge", "levels": 3}],
        "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_piercing" },
        "on_false": {
          "type": "condition",
          "property": "minecraft:component",
          "component": "minecraft:enchantments",
          "predicate": "minecraft:enchantments",
          "value": [{"enchantments": "minecraft:piercing", "levels": 4}],
          "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/piercing" },
          "on_false": {
            "type": "condition",
            "property": "minecraft:component",
            "component": "minecraft:enchantments",
            "predicate": "minecraft:enchantments",
            "value": [{"enchantments": "minecraft:quick_charge", "levels": 3}],
            "on_true": { "type": "model", "model": "cit_new:item/tools/crossbow/quick_charge" },
            "on_false": { "type": "model", "model": "minecraft:item/crossbow" }
          }
        }
      }
    }
  }
}